/* This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://sam.zoy.org/wtfpl/COPYING for more details. */

#include "Block.hpp"

double Block::trace(Vector3d& direction, Vector3d position, double distance)
{
	double hitDist = std::numeric_limits<double>::infinity();
	unsigned hitNum = 4;
	bool forwards = false;
	for(int i = 0; i < 3; ++i) {
		double hitPos = (direction[i] < 0) ? (-dimensions[i]-position[i])/direction[i] : (dimensions[i]-position[i])/direction[i];
		if(hitPos < hitDist) {
			hitNum = i;
			hitDist = hitPos;
			forwards = (direction[i] < 0);
		}
	}
	if(distance + hitDist > 8) return 8;
	if(!neighbours[hitNum][forwards?1:0])
		return distance + hitDist;
	
	for(int i = 0; i < 3; ++i) position[i] = position[i] + direction[i]*hitDist;
	position[hitNum] *= -neighbours[hitNum][forwards?1:0]->dimensions[hitNum]/dimensions[hitNum];

	return neighbours[hitNum][forwards?1:0]->trace(direction, position, distance + hitDist);
}
