/* This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://sam.zoy.org/wtfpl/COPYING for more details. */

#ifndef CGAL_DEFINES_HEADER
#define CGAL_DEFINES_HEADER

#include <CGAL/Triangulation_euclidean_traits_2.h>
#include <CGAL/Delaunay_triangulation_2.h>
#include <CGAL/Cartesian.h>
#include <CGAL/Point_2.h>
#include <CGAL/Triangulation_vertex_base_with_info_2.h>
#include <CGAL/point_generators_2.h>
#include <CGAL/algorithm.h>

typedef CGAL::Cartesian<double> Field;
typedef CGAL::Point_2<Field> Point;

typedef CGAL::Triangulation_euclidean_traits_2<Field> EuclideanTraits;
typedef CGAL::Triangulation_vertex_base_with_info_2<double, EuclideanTraits> VertexBase;
typedef CGAL::Triangulation_face_base_2<EuclideanTraits> FaceBase;

typedef CGAL::Triangulation_default_data_structure_2<EuclideanTraits, VertexBase, FaceBase> DataStructure;

typedef CGAL::Delaunay_triangulation_2<EuclideanTraits, DataStructure> Triangulation;

#endif
