/* This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://sam.zoy.org/wtfpl/COPYING for more details. */

#ifndef GAME_HPP
#define GAME_HPP

#include "Player.hpp"
#include "CGALDefines.hpp"
#include <SFML/Graphics.hpp>
#include <vector>

class Game
{
	public:
		Game(Player&, unsigned=600, unsigned=600, unsigned=5000);
		void play();
	private:
		std::vector<Triangulation> triangulations;
		Player& player;
		sf::RenderWindow window;
		bool running;
		unsigned points;
		unsigned width, height;
		CGAL::Random_points_in_square_2<Point> generator;
		void processEvents();
		bool captureMouse;
};

#endif
